model saclay

global {
	file shape_file_buildings <- file("../includes/osm_polygon.shp");
	file shape_file_roads <- file("../includes/osm_line.shp");
	file shape_file_bounds <- file("../includes/osm_point.shp");
	geometry shape <- envelope(shape_file_bounds);
	float step <- 10 #mn;
	
	init {
		create building from: shape_file_buildings with: [type::string(read ("building")), amenity::string(read ("amenity"))] {
			if (type!="yes" and type!="station") {
//				write("kill "+self.name);
				do die;
			}
			if name contains "Bâtiment"
			{
				color<-#blue;
			}
			if name!=""
			{
				color<-#blue;
			}
		}
		create road from: shape_file_roads with: [type::string(read ("highway"))] {
			color<-#blue;
			if type=""
			{
				write("kill "+self.name);
				do die;
			}
			if type="footway" {
				color <- #green ;
			}
		}
	}
}

species building {
	string type; 
	string amenity;
	rgb color <- #gray  ;
	
	aspect base {
		draw shape color: color ;
	}
}

species road  {
	string type;
	rgb color <- #black ;
	aspect base {
		draw shape color: color ;
	}
}

experiment saclay type: gui {
	parameter "Shapefile for the buildings:" var: shape_file_buildings category: "GIS" ;
	parameter "Shapefile for the roads:" var: shape_file_roads category: "GIS" ;
	parameter "Shapefile for the bounds:" var: shape_file_bounds category: "GIS" ;
	
	output {
		display city_display type:opengl {
			species building aspect: base ;
			species road aspect: base ;
		}
	}
}